% <classify_cicoc.m: SVM Classification function>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%
function [ConfMat,acc,oofLabel,Mdl,l_predict,score_predict,ConfMat_predict] = classify_cicoc(y_train,labelstrain,y_tests,l_tests,t,base_name)
fprintf('to train mdl\n');
options = statset('UseParallel',0);
Mdl = fitcecoc(y_train',labelstrain,'Learners',t,'Coding','onevsall','Verbose',2,'Options',options);
%Mdl = fitcecoc(y_train',labelstrain,'Learners',t,'Coding','onevsone','Verbose',2,'Options',options);
%Mdl = fitcecoc(y_train',labelstrain,'Learners',t,'Coding','binarycomplete','Verbose',2,'Options',options);

sname = strcat(base_name,'mdl.mat');
save(sname,'Mdl');
sname = '';

l_predict = []; score_predict = []; ConfMat_predict = [];
if(numel(y_tests) > 0)
    fprintf('to predict for test values\n');
    [l_predict,score_predict] = predict(Mdl,y_tests');
    sname = strcat(base_name,'l_predict.mat');
    save(sname,'l_predict');
    sname = '';
    sname = strcat(base_name,'score_predict.mat');
    save(sname,'score_predict');
    sname = '';
    fprintf('to plot confucion matrix for test values\n');
    ConfMat_predict = confusionmat(l_tests,l_predict);
    sname = strcat(base_name,'ConfMat_predict.mat');
    save(sname,'ConfMat_predict');
    sname = '';
    
    fprintf('to compute accuracy test set\n');
    su = 0;
    for i =1:size(ConfMat_predict,1)
        su = su + ConfMat_predict(i,i);
    end
    
    acc = su / size(y_tests,2)
end

ConfMat = [];
oofLabel = [];

fprintf('to do cross validation on training\n');
CVMdl = crossval(Mdl,'Options',options);
oofLabel = kfoldPredict(CVMdl,'Options',options);
fprintf('to make confusion matrix for training cross vals\n');
ConfMat = confusionmat(labelstrain,oofLabel);

sname = strcat(base_name,'confmat_train.mat');
save(sname,'ConfMat');
sname = '';
 
fprintf('to compute accuracy cross vals training\n');
su = 0;
for i =1:size(ConfMat,1)
    su = su + ConfMat(i,i);
end

acc = su / size(y_train,2)
