% <get_parts.m: Reading parts based on patch adjacency and relationship>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%

function data = get_parts(config,t_id)

fprintf('to read parts from hard drive\n');

path_dir = [];
if(t_id == 1)
    path_dir = strcat(config.orig_path,config.train_part_path);
else
    path_dir = strcat(config.orig_path,config.test_part_path);
end
path = strcat(path_dir,'*');

files = dir(path);

data = [];

fprintf('to process parts\n');
cid = 1;
for i = 1:size(files,1)
    file_name = files(i,1).name;
    t = findstr(file_name,'.');
    if((t > 0) & (t <= numel(file_name)) )
        continue;
    end 

    
    file_name
    seg_file = strcat(path_dir,file_name,'/segs.txt');
    part_file = strcat(path_dir,file_name,'/part.txt');
    cvt_file = strcat(path_dir,file_name,'/cvt.txt');
    
    fileID = fopen(seg_file);
    b = textscan(fileID,'%s','Delimiter',',');
    a = [];
    for r =1:size(b{1})
        a{r} = str2num(b{1}{r});
    end
    fclose(fileID); 
    
    fileID = fopen(part_file);
    b = textscan(fileID,'%f %f','Delimiter',',');
    p = cell2mat(b);
    fclose(fileID);
    
    fileID = fopen(cvt_file);
    b = textscan(fileID,'%f %f %f','Delimiter',',');
    c = cell2mat(b);
    fclose(fileID);
    
    data.segs{cid} = a;
    data.parts{cid} = p;
    data.cvts{cid} = c;
    data.file_names{cid} = file_name;
    cid = cid + 1;
end

base_name = config.data_path;
sname = '';
if(t_id == 1)
    sname = strcat(base_name,config.train_parts_mat);
else
    sname = strcat(base_name,config.test_parts_mat);
end
save(sname,'data');
