% <get_patches.m: Reading features of the patches>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%
function data = get_patches(config,t_id)

fprintf('to read patches from hard drive\n');

path_dir = [];
if(t_id == 1)
    path_dir = strcat(config.orig_path,config.train_patch_path);
else
    path_dir = strcat(config.orig_path,config.test_patch_path);
end
path = strcat(path_dir,'*_sim.txt');

files = dir(path);

data = [];

fprintf('to process patches\n');
cid = 1;
seg_def = 10;
for i=1:size(files,1)     
    si_name = files(i,1).name;
    si_name = strcat(path_dir,si_name)
    t = findstr(si_name,'sim.txt');
    root_name = si_name(1:t-1);
    
    
    data.files_names(cid).name = root_name;
    
    fileID = fopen(si_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    if(numel(a) == 0)
        a = zeros(1,seg_def);
    end
    
    data.sim(:,cid) = a;
    fclose(fileID);   
    
    cv_name = strcat(root_name,'cvm.txt');
    sia_name = strcat(root_name,'simax.txt');
    cva_name = strcat(root_name,'cvmax.txt');
    hn_name = strcat(root_name,'histn.txt');
    hc_name = strcat(root_name,'histc.txt');
    cvt_name= strcat(root_name,'curv.txt');
    nn_name = strcat(root_name,'normal.txt');

    fileID = fopen(cv_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    if(numel(a) == 0)
        a = zeros(1,seg_def);
    end
    data.cvm(:,cid) = a;
    fclose(fileID); 

    fileID = fopen(sia_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    if(numel(a) == 0)
        a = zeros(1,seg_def);
    end
    data.simax(:,cid) = a; 
    fclose(fileID); 
    
    fileID = fopen(cva_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    if(numel(a) == 0)
        a = zeros(1,seg_def);
    end    
    data.cvmax(:,cid) = a;
    fclose(fileID); 

    
    fileID = fopen(hn_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    data.histn(:,cid) = a;
    fclose(fileID);

    fileID = fopen(hc_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    data.histc(:,cid) = a;
    fclose(fileID);

    fileID = fopen(cvt_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    data.curv{cid} = a;
    fclose(fileID);

    fileID = fopen(nn_name);
    b = textscan(fileID,'%f','HeaderLines',2,'Delimiter',',');
    a=cell2mat(b);
    a = reshape(a,1,length(a));
    data.normals{cid} = a;
    fclose(fileID);
    
    cid = cid+1;
end

base_name = config.data_path;
sname = '';
if(t_id == 1)
    sname = strcat(base_name,config.train_patches_mat);
else
    sname = strcat(base_name,config.tests_patches_mat);
end
save(sname,'data');
