% <make_config.m: Making configuration of variables>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%
function config = make_config()

config.orig_path = strcat(pwd,'/');
config.parts_save_path = 'segmented_parts_txt/';
config.parts_features_path = 'evals_pcd/';
% if true, planar parts will be segmented from the pointcloud
config.seg_planar_test = true;
config.data_path = strcat(pwd,'/data/');
config.eval_parts_path = 'segmented_parts/';
config.test_parts_mat = 'tests_parts_pcd.mat';
config.tests_patches_mat = 'tests_pcd.mat';
config.patch_cls_mat = 'means_pcd.mat';
config.part_cls_mat = 'means_parts_pcd.mat';
config.train_part_hist = 'parts_hists_pcd_novel.mat';
config.test_part_hist = 'parts_hists_test_pcd_novel.mat';
config.occ_mat = 'part_occ_pcd.mat';
config.occ_prob_mat = 'part_occ_prob_pcd.mat';
config.mdl_cvt = 'rbf-cvt-patch-pair-pcd/prob_svms.mat';
config.svm_cvt_dir = 'cvt-patch-pair-pcd/';
config.mrf_weights = 'weights_pcd.mat';
config.train_parts_mat = 'trains_parts_pcd.mat';
config.train_patches_mat = 'trains_pcd.mat';
config.segmented_parts_mat = 'seg-parts-pcd-novel.mat';
config.train_files_path = 'train_data/';
config.test_files_path = 'test_data/';
config.train_patch_path = 'patches-pcl-train-txt/';
config.test_patch_path = 'patches-pcl-test-txt/';
config.train_part_path = 'parts-pcd/';
config.test_part_path = 'parts-test-pcd/';
