% <mrf_test_cvt.m: MRF based segmentation of object parts>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%

function [optimalDecoding] = mrf_test_cvt(patches_adj,pts,cvts,cls_ids,p_occ_prob,nStates,w_unary,w_pair,Mdl)

burnIn = 100;
%epsilon = 1e-3;
nNodes = numel(patches_adj);
adj = zeros(nNodes,nNodes);
cn = zeros(nNodes,nNodes);

for i =1:numel(patches_adj)
    a = patches_adj{i};
    if(numel(a) < 2)
        continue;
    end
    for j =2:numel(a)
        adj(a(1)+1,a(j)+1) = 1;
      % cn(a(1)+1,a(j)+1) = 1;
    end    
end

edgeStruct = UGM_makeEdgeStruct(adj,nStates);

if(edgeStruct.nEdges == 0)
    optimalDecoding = [];
    for i = 1:nNodes
        optimalDecoding(i) = i;
    end
    return;
end

nodePot = zeros(nNodes,nStates);
for i = 1:nNodes
    id = find(pts.ids == i-1);
    cl_id = cls_ids(id);
    for j = 1:nStates
        % p(y_i \vert x_i)
        prob = 0;
        if(numel(cl_id) == 1)
            prob = p_occ_prob(j,cl_id);
        end
%         if(prob < epsilon)
%             prob = epsilon;
%         end
        nodePot(i,j) = exp(-w_unary(j)*(1-prob));
      %   nodePot(i,j) = exp(-w_unary(j)*(prob));
    end
end

maxState = max(edgeStruct.nStates);
edgePot = zeros(maxState,maxState,edgeStruct.nEdges);

 max_val = 1e+3;
 min_val = 1e-5;
for i = 1:maxState
    for j = 1:maxState
        for e = 1:edgeStruct.nEdges
            edgePot(i,j,e) = min_val;
        end
    end
end

% for i = 1:maxState
%     for j = 1:maxState
%         for e = 1:edgeStruct.nEdges
%             id1 = edgeStruct.edgeEnds(e,1);
%             id2 = edgeStruct.edgeEnds(e,2);
%             ids1 = find(cvts(:,1) == id1-1);
%             ids2 = find(cvts(:,2) == id2-1);
%             id_c = intersect(ids1,ids2);
%             c = 0;
%             l_predict = [];
%             score_predict = [];
%             ic1 = 0; ic2 = 0;
%             score = 0;
%             if(numel(id_c) == 1)
%                 c = cvts(id_c(1),3);
%                 [l_predict,score_predict] = predict(Mdl,c);
%                 if(numel(l_predict) > 0)
%                     ic1 = l_predict;
%                     ic2 = 2 - ic1 + 1;
%                     %  score = 1 - ( score_predict(ic1) / score_predict(ic2) );
%                     score = ( score_predict(ic1) / score_predict(ic2) );
%                 end
%             end
%             if(i == j) & (cn(id1,id2) == 1)
%                 %edgePot(i,j,e) = 0;
%                 edgePot(i,j,e) = max_val;
%                 continue;
%             end
%             if(cn(id1,id2) == 0) & (i == j)
%                % edgePot(i,j,e) = max_val;
%                 edgePot(i,j,e) = min_val;
%                 continue;
%             end
%             if(cn(id1,id2) == 0)
%                 continue;
%             end
%            % edgePot(i,j,e) = exp(- w_pair(i,j) * c);
%             if(l_predict(1) == 2)
%                 edgePot(i,j,e) = exp(- w_pair(i,j) *abs(score));
%             else
%               %  edgePot(i,j,e) = 10;
%               edgePot(i,j,e) = 1e-2;
%             end
%             
%         end
%     end
% end

for e = 1:edgeStruct.nEdges
    id1 = edgeStruct.edgeEnds(e,1);
    id2 = edgeStruct.edgeEnds(e,2);
    ids1 = find(cvts(:,1) == id1-1);
    ids2 = find(cvts(:,2) == id2-1);
    id_c = intersect(ids1,ids2);
    c = cvts(id_c(1),3);
%     [l_predict,score_predict] = predict(Mdl,c);
%     ic1 = l_predict;
%     ic2 = 2 - ic1 + 1;
%     score = 1 - ( score_predict(ic1) / score_predict(ic2) );
%     score = ( score_predict(ic1) / score_predict(ic2) );
    [l_predict,p_predict] = predict(Mdl,c);
    for i = 1:maxState
        for j = 1:maxState
            if(i == j)
                edgePot(i,j,e) = 1;
                continue;
            end
            if(l_predict(1) == 2)
              %  edgePot(i,j,e) = exp(- w_pair(i,j) *abs(score));
                edgePot(i,j,e) = exp(- w_pair(i,j) *(1 - p_predict(2)));
            else
                edgePot(i,j,e) = min_val;
            end
        end
    end
end


%edgePot
edgeStruct.useMex = 0;
edgeStruct.maxIter = 100; 
%UGM_Decode_GraphCut, UGM_Decode_LBP
%optimalDecoding = UGM_Decode_MaxOfMarginals(nodePot,edgePot,edgeStruct,@UGM_Infer_Sample,@UGM_Sample_Gibbs,burnIn);
%optimalDecoding = UGM_Decode_Exact(nodePot,edgePot,edgeStruct)
%optimalDecoding = UGM_Decode_LBP(nodePot,edgePot,edgeStruct);
optimalDecoding = UGM_Decode_MaxOfMarginals(nodePot,edgePot,edgeStruct,@UGM_Infer_LBP);
% edgeStruct.maxIter = 100;
%samples = UGM_Sample_Exact(nodePot,edgePot,edgeStruct);
% samples = UGM_Sample_Chain(nodePot,edgePot,edgeStruct);
% imagesc(samples');
% ylabel('states');
% xlabel('patches');
