% <mrf_train_demo.m: MRF based training>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%

function [w] = mrf_train_demo(train_parts_all,patch_names,patch_fets,patch_cls,part_cls,p_occ_prob,Mdl,config)
path = config.data_path;
train_parts = [];
num_samps = 1000;

if(numel(train_parts_all.segs) < num_samps)
    num_samps = numel(train_parts_all.segs);
end

id_part = 0;
while id_part < num_samps
    ids = randi(numel(train_parts_all.segs),1,1);
    i = ids(1);
    cur_segs = train_parts_all.segs{ids(1)};
    if(numel(cur_segs) == 0)
        continue;
    end
    id_part = id_part +1;
    train_parts.segs{id_part} = train_parts_all.segs{ids(1)};
    train_parts.parts{id_part} = train_parts_all.parts{ids(1)};
    train_parts.cvts{id_part} = train_parts_all.cvts{ids(1)};
    train_parts.file_names{id_part} = train_parts_all.file_names{ids(1)};    
end

%batch_size = 200;
batch_size = 50;

nStates = size(part_cls,1);
param_size = ( ( nStates * (nStates -1) )/ 2) + nStates;
w = rand(param_size,1) + 0.1;
% w = randi(100,param_size,1);
%w = 0.1*randn(param_size,1);
prev_w = w;
%w_all = [];
%y_all = [];
eta = 0.9;
dec_eta = 1e-2;
%maxepoch = 400;
maxepoch = 10;
k = 0;

burnIn = 100;

%    maxepoch = 5;
%    batch_size = 1;
fprintf('initialization\n'); 

[y,data_prob] = prepare_data(train_parts,patch_names,patch_fets,patch_cls,part_cls,p_occ_prob,w,Mdl);
make_minibatches(y,batch_size);
b = make_minibatches(y,batch_size);
%size(b)

%maxSamples = size(b,2);
maxSamples = 20;
%maxSamples = 5;

for epoch = 1:maxepoch
    fprintf('In epoch %d from %d\n',epoch,maxepoch);
    for i = 1:batch_size
        fprintf('In batch %d from %d\n',i,batch_size);
        expt_samples = 0;
        g_k = 0; 
        fprintf('to generate samples\n'); 
%         for s = 1:maxSamples
%            % fprintf('to generate sample %d from %d : %d %d \n',s,maxSamples,i,epoch);
%            % id_s = randi(size(b,2));
%             id_s = s;
%             nodePot = y.nodePots{b(i,id_s)};
%             edgePot = y.edgePots{b(i,id_s)};
%             edgeStruct = y.edgeStructs{b(i,id_s)};
%             edgeStruct.maxIter = 100;
%              samplesGibbs = UGM_Sample_Gibbs(nodePot,edgePot,edgeStruct,burnIn);
%              cur_decoding = samplesGibbs(:,edgeStruct.maxIter);
%            %  size(samplesGibbs)
% %             samplesGibbs(:,edgeStruct.maxIter)
% %             samplesGibbs = UGM_Sample_Gibbs(nodePot,edgePot,edgeStruct,burnIn,samplesGibbs(:,edgeStruct.maxIter));
%             %[gibbsNodeBel,gibbsEdgeBel,gibbsLogZ] = UGM_Infer_Sample(nodePot, edgePot, edgeStruct,@UGM_Sample_Gibbs,burnIn);
%             %gibbsLogZ
%             %gibbsNodeBel
%             %expt_samples = expt_samples + gibbsLogZ;
%            % cur_decoding = UGM_Decode_MaxOfMarginals(nodePot,edgePot,edgeStruct,@UGM_Infer_Sample,@UGM_Sample_Gibbs,burnIn);
%             pot = -computeUnnormalizedPotentials(cur_decoding,nodePot,edgePot,edgeStruct,w);
%             logz = computeNormalizedPotentials(cur_decoding,nodePot,edgePot,edgeStruct,w);
%           %  nNodes = double(edgeStruct.nNodes);
%             nEdges = double(edgeStruct.nEdges);
%             g_k = g_k +( (pot + logz) / nEdges);
%             expt_samples = expt_samples + logz;
%         end
%         expt_samples = expt_samples  / maxSamples;
%         g_k = 0;
        for j = 1:size(b,2)
           % fprintf('to infer for data %d from %d : %d %d \n',j,size(b,2),i,epoch);
            nodePot = y.nodePots{b(i,j)};
            edgePot = y.edgePots{b(i,j)};
            edgeStruct = y.edgeStructs{b(i,j)};
%             [nodeBel, edgeBel, logZ] = UGM_Infer_LBP(nodePot,edgePot,edgeStruct);
%             size(nodeBel)
%             size(edgeBel)
%             logZ  
            expt_samples = 0;
            for s = 1:maxSamples
                edgeStruct.maxIter = 100;
                samplesGibbs = UGM_Sample_Gibbs(nodePot,edgePot,edgeStruct,burnIn);
                cur_decoding = samplesGibbs(:,edgeStruct.maxIter);
              %  cur_decoding = UGM_Decode_MaxOfMarginals(nodePot,edgePot,edgeStruct,@UGM_Infer_Sample,@UGM_Sample_Gibbs,burnIn);
              pot = -computeUnnormalizedPotentials(cur_decoding,nodePot,edgePot,edgeStruct,w);
              nEdges = double(edgeStruct.nEdges);
              pot = pot / nEdges;
              if(isnan(pot) | isinf(pot))
                  continue;
              end
                  expt_samples = expt_samples + pot;
            end
            expt_samples = expt_samples / maxSamples;
            % cur_decoding = UGM_Decode_MaxOfMarginals(nodePot,edgePot,edgeStruct,@UGM_Infer_LBP);
            cur_decoding = UGM_Decode_MaxOfMarginals(nodePot,edgePot,edgeStruct,@UGM_Infer_Sample,@UGM_Sample_Gibbs,burnIn);
            pot = -computeUnnormalizedPotentials(cur_decoding,nodePot,edgePot,edgeStruct,w);
            nEdges = double(edgeStruct.nEdges);
            pot = pot / nEdges;
            if(isnan(pot) | isinf(pot))
                continue;
            end
%             pot = (pot + expt_samples) / nEdges;
%             g_k = g_k + pot;
           % pot
           % expt_samples
            cur_gk = pot - expt_samples;
            g_k = g_k + cur_gk;
         %  return;
         end
        
        g_k = g_k / size(b,2);
        fprintf('to update weights %f\n',g_k); 
     %   return;
      %  w
   %     return;
       % prev_w = [];
%         if(k > 0)
%             prev_w = w_all(k,:);
%         else
%             prev_w = w;
%         end
     %   w_all(k+1,:) = prev_w - eta*g_k;
        if(isnan(g_k) | isinf(g_k))
            continue;
        end
        cur_w = w;
        w = prev_w - eta*g_k;
        epsilon = 1e-3;
        id_zeros = find(w < epsilon);
        if(numel(id_zeros) > 0)
           % w(id_zeros) = epsilon;
            w(id_zeros) = cur_w(id_zeros);
        end
        id_nan = find(isnan(w));
       % w(id_nan) = epsilon;
        w(id_nan) = cur_w(id_nan);
        id_inf = find(isinf(w));
       % w(id_inf) = epsilon;
        w(id_inf) = cur_w(id_nan);
        
        prev_w = cur_w;
      %  y_all.graph{k+1} = y;
        y = update_data(data_prob,w,nStates);
        %y = prepare_data(train_parts,patch_names,patch_fets,patch_cls,part_cls,p_occ_prob,p_joints_patch_prob,w);
        k = k+1;
        
        w_name = '';
        w_name = strcat(path,'weights/','weights',num2str(i),'_',num2str(epoch),'.mat');
   %     save(w_name,'prev_w');
    %    eta = eta - dec_eta;
      %  return;
    end
end
%w_name = strcat(path,'weights.mat');
w_name = strcat(path,config.mrf_weights);
%w_last = w_all(end,:);
w_last = w;
save(w_name,'w_last');
w_name = '';

% w_name = strcat(path,'weights_all.mat');
% save(w_name,'w_all');

% data_name = strcat(path,'data_graphs.mat');
% save(data_name,'y_all');
%%
function [w_unary,w_pair] = make_weights_matrices(w,nStates)

for i = 1:nStates
    w_unary(i) = w(i);
end

w_rest = w(nStates+1:end);
w_pair = zeros(nStates,nStates);
cid = 1;
for i = 1:nStates
    for j = i+1:nStates
        w_pair(i,j) = w_rest(cid);
        w_pair(j,i) = w_rest(cid);
        cid = cid+1;
    end
end

%%
function pot = computeUnnormalizedPotentials(y,nodePot,edgePot,edgeStruct,w)
nNodes = edgeStruct.nNodes;
nEdges = edgeStruct.nEdges;
edgeEnds = edgeStruct.edgeEnds;
%nStates = edgeStruct.nStates;
%[w_unary,w_pair] = make_weights_matrices(w,nStates);

pot = 0;
epsilon = 1e-3;
for n = 1:nNodes
    cur_prob = nodePot(n,y(n));
%     cur_prob = exp(-w_unary(y(n))*(1. - prob));  
    if(cur_prob < epsilon)
        cur_prob = epsilon;
    end
    cur_log = log(cur_prob);
    if(isinf(cur_log) | isnan(cur_log))
        cur_log = epsilon;
    end
    pot = pot + cur_log;
end
for e = 1:nEdges
    n1 = edgeEnds(e,1);
    n2 = edgeEnds(e,2);
    cur_prob = edgePot(y(n1),y(n2),e);
%     prob = 0;
%     cur_prob = 0;
%     if(y(n1) == y(n2))
%         prob = 0;
%         cur_prob = 0;
%     else
%         prob = edgePot(y(n1),y(n2),e);
%         cur_prob = exp(-w_pair(y(n1),y(n2)) *(1. -  prob) );
%     end
    if(cur_prob < epsilon)
        cur_prob = epsilon;
    end  
    cur_log = log(cur_prob);
    if(isinf(cur_log) | isnan(cur_log))
        cur_log = epsilon;
    end    
    pot = pot + cur_log;
end
%%
function pot = computeNormalizedPotentials(y,nodePot,edgePot,edgeStruct,w)
nNodes = edgeStruct.nNodes;
nEdges = edgeStruct.nEdges;
edgeEnds = edgeStruct.edgeEnds;
pot = 0;
epsilon = 1e-3;
% nStates = edgeStruct.nStates;
% [w_unary,w_pair] = make_weights_matrices(w,nStates);

for i = 1:size(nodePot,1)
    for j = 1:size(nodePot,2)
        cur_prob = nodePot(i,j);
%         prob = nodePot(i,j);
%         cur_prob = exp(-w_unary(j)*(1. - prob));
        if(cur_prob < epsilon)
            cur_prob = epsilon;
        end        
        cur_log = log(cur_prob);
        if(isinf(cur_log) | isnan(cur_log))
            cur_log = epsilon;
        end
        pot = pot + cur_log;
    end
end

for i = 1:size(edgePot,1)
    for j = 1:size(edgePot,2)
        for e = 1:size(edgePot,3)
            cur_prob = edgePot(i,j,e);
%             prob = 0;
%             cur_prob = 0;
%             if(i == j)
%                 prob = 0;
%                 cur_prob = 0;
%             else
%                 prob = edgePot(i,j,e);
%                 cur_prob = exp(-w_pair(i,j) *(1. -  prob) );
%             end
            if(cur_prob < epsilon)
                cur_prob = epsilon;
            end
            cur_log = log(cur_prob);
            if(isinf(cur_log) | isnan(cur_log))
                cur_log = epsilon;
            end
            pot = pot + cur_log;
        end
    end
end
%%
function b = make_minibatches(y,batch_size)
p = randperm(numel(y.nodePots));
s = floor(numel(y.nodePots) / batch_size);
for i = 1:batch_size
  %  fprintf('from %d to %d in %d, %d\n',(i-1)*s+1,i*s,numel(y.nodePots),s);
    b(i,:) = p((i-1)*s+1:i*s);
end
%%
function y = update_data(data_prob,w,nStates)
epsilon = 1e-2;
[w_unary,w_pair] = make_weights_matrices(w,nStates);
for id_part = 1:numel(data_prob.nodeProbs)   
  %  fprintf('to update data %d from %d\n',id_part,numel(data_prob.nodeProbs));
    nodePot = data_prob.nodeProbs{id_part};
    edgePot = data_prob.edgeProbs{id_part};
    edgeStruct = data_prob.edgeStructs{id_part};
    
    for i = 1:size(nodePot,1)
        for j = 1:size(nodePot,2)
            prob = nodePot(i,j);
            nodePot(i,j) = exp(-w_unary(j)*(prob));
         %   nodePot(i,j) = w_unary(j) * exp(-prob);
        end
    end

    for i = 1:size(edgePot,1)
        for j = 1:size(edgePot,2)
            for e = 1:size(edgePot,3)
                if(i == j)
                    prob = 0;
                    edgePot(i,j,e) = 0;
                else
                    prob = edgePot(i,j,e);
                    edgePot(i,j,e) =  exp(-w_pair(i,j) *(prob) );
                 %   edgePot(i,j,e) =  w_pair(i,j) * exp(-prob);
                end
                
                if(edgePot(i,j,e) < epsilon)
                    edgePot(i,j,e) = epsilon;
                end
            end
        end
    end
    
    y.nodePots{id_part} = nodePot;
    y.edgePots{id_part} = edgePot;
    y.edgeStructs{id_part} = edgeStruct;    
end
%%
function [y,data_prob] = prepare_data(train_parts,patch_names,patch_fets,patch_cls,part_cls,p_occ_prob,w,Mdl)
epsilon = 1e-2;
nStates = size(part_cls,1);

data_prob = [];
[w_unary,w_pair] = make_weights_matrices(w,nStates);
cids = 1;
for id_part = 1:numel(train_parts.segs)
%for id_part = 1:20
    fprintf('to read data %d from %d\n',id_part,numel(train_parts.segs));
    %train_parts.file_names(id_part)
    patches_adj = train_parts.segs{id_part};
    f_name = train_parts.file_names{id_part};
    pts = give_patches(f_name,patch_names,patch_fets);
    cls_ids = get_patch_cls_id(patch_cls,pts.fets');
    
    cvts = train_parts.cvts{id_part};
    
    nNodes = numel(patches_adj);
%     
%     if(nNodes == 0)
%         continue;
%     end
    adj = zeros(nNodes,nNodes);
    
    for i =1:numel(patches_adj)
        a = patches_adj{i};
        if(numel(a) < 2)
            continue;
        end
        for j =2:numel(a)
            adj(a(1)+1,a(j)+1) = 1;
        end
    end
    
    edgeStruct = UGM_makeEdgeStruct(adj,nStates);
    edgeStruct.useMex = 0;
    
    nodePot = zeros(nNodes,nStates);
    nodeProb = zeros(nNodes,nStates);
    for i = 1:nNodes
        id = find(pts.ids == i-1);
        cl_id = cls_ids(id);
        for j = 1:nStates
            % p(y_i \vert x_i)
            prob = 0;
            if(numel(cl_id) == 1)
                prob = p_occ_prob(j,cl_id);
            end
            %             if(prob < epsilon)
            %                 prob = epsilon;
            %             end
            %nodePot(i,j) = exp(-w_unary(j)*(prob));
            nodePot(i,j) = exp(-w_unary(j)*(1-prob));
            nodeProb(i,j) = 1 - prob;
          %  nodeProb(i,j) = prob;
        end
    end
    
    maxState = max(edgeStruct.nStates);
    edgePot = zeros(maxState,maxState,edgeStruct.nEdges);
    edgeProb = zeros(maxState,maxState,edgeStruct.nEdges);
    %     for i = 1:nStates
    %         for j = 1:nStates
    %             for e = 1:edgeStruct.nEdges
    %                 v1 = edgeStruct.edgeEnds(e,1);
    %                 v2 = edgeStruct.edgeEnds(e,2);
    %                 id1 = find(pts.ids == v1-1);
    %                 id2 = find(pts.ids == v2-1);
    %                 cl_id1 = cls_ids(id1);
    %                 cl_id2 = cls_ids(id2);
    %                 if(cl_id2 < cl_id1)
    %                     tmp = cl_id1;
    %                     cl_id1 = cl_id2;
    %                     cl_id2 = tmp;
    %                 end
    %                 prob = 0;
    %                 if(i == j)
    %                     prob = 0;
    %                     edgePot(i,j,e) = 0;
    %                     % lets skip for now, penalize all the non equall
    %                     % combinations equally
    %                     %prob = p_joints_patch_prob(cl_id1,cl_id2,1);
    %                 else
    %                     prob = p_joints_patch_prob(cl_id1,cl_id2,2);
    %                     edgePot(i,j,e) =  exp(- w_pair(i,j) * (prob) );
    %                 end
    %
    %                 if(edgePot(i,j,e) < epsilon)
    %                     edgePot(i,j,e) = epsilon;
    %                 end;
    %                 edgeProb(i,j,e) = prob;
    %             end
    %         end
    %     end
    
    for e = 1:edgeStruct.nEdges
        v1 = edgeStruct.edgeEnds(e,1);
        v2 = edgeStruct.edgeEnds(e,2);
        
        ids1 = find(cvts(:,1) == v1-1);
        ids2 = find(cvts(:,2) == v2-1);
        id_c = intersect(ids1,ids2);
        c = cvts(id_c(1),3);
%         [l_predict,score_predict] = predict(Mdl,c);
%         ic1 = l_predict;
%         ic2 = 2 - ic1 + 1;
%         score = ( score_predict(ic1) / score_predict(ic2) );
        [l_predict,p_predict] = predict(Mdl,c);
        for i = 1:nStates
            for j = 1:nStates
                prob = 0;
                if(i == j)
                    prob = 0;
                    %edgePot(i,j,e) = 0;
                    edgePot(i,j,e) = 1;
                else
                    if(l_predict(1) == 2)
                      %  edgePot(i,j,e) = exp(- w_pair(i,j) *abs(score));
                       % prob = abs(score);
                       prob = 1 - p_predict(2);
                       edgePot(i,j,e) = exp(- w_pair(i,j) *prob);
                    else
                        edgePot(i,j,e) = 0;
                        prob = 1;
                    end
                end
                
                if(edgePot(i,j,e) < epsilon)
                    edgePot(i,j,e) = epsilon;
                end
                edgeProb(i,j,e) = prob;
            end
        end
    end
    
    %count
    %numel(find(edgePot == 0))
    y.nodePots{cids} = nodePot;
    y.edgePots{cids} = edgePot;
    y.edgeStructs{cids} = edgeStruct;
    
    data_prob.nodeProbs{cids} = nodeProb;
    data_prob.edgeProbs{cids} = edgeProb;
    data_prob.edgeStructs{cids} = edgeStruct;    
    cids = cids +1;
end
%%
function pts = give_patches(f_name,patch_names,patch_fets)

cid = 1;
for i = 1:numel(patch_names)
    cur_id_str = patch_names(i).name;
    t = findstr(cur_id_str,f_name);
    if(numel(t) == 0)
        continue;
    end
    t = findstr(patch_names(i).name,'_');
    cur_id_str = cur_id_str(t(numel(t)-1)+1:t(numel(t))-1);
    cur_id = str2num(cur_id_str);
    pts.ids(cid) = cur_id;
    pts.fets(:,cid) = patch_fets(:,i);
    cid = cid +1;
end
%%
function cls_ids = get_patch_cls_id(patch_cls,patch_fets)

[dists,cls_ids] = pdist2(patch_cls,patch_fets,'euclidean','Smallest',1);
