% <test_script.m: Script for part segmentation of test pointclouds>
%     Copyright (C) <2017>  <Safoura Rezapour Lakani>
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <http://www.gnu.org/licenses/>.

%%
path = config.data_path;

%%
% call c++ feature extraction
ref_path = strcat(pwd,'/code-extract-features/build/');
fet_ext = strcat(ref_path,'vis'); 
data_path = strcat(config.orig_path,config.test_files_path);
data_patch_path = strcat(config.orig_path,config.test_patch_path);
data_parts_path = strcat(config.orig_path,config.test_part_path);
fet_ext_command = '';
if(config.seg_planar_test)
    fet_ext_command = strcat(fet_ext,{' '},'testp',{' '},data_path,{' '},data_patch_path,{' '},data_parts_path);
else
    fet_ext_command = strcat(fet_ext,{' '},'test',{' '},data_path,{' '},data_patch_path,{' '},data_parts_path);
end
fet_ext_command_str = fet_ext_command{1}
[status,cmdout] = system(fet_ext_command_str,'-echo');

%%

fprintf('to get test patches\n');
tests = get_patches(config,2);

fprintf('to get test parts\n');
test_parts = get_parts(config,2);

test_patch_names = tests.files_names;
test_patch_fets = tests.histn;

patch_cls_str = strcat(path,config.patch_cls_mat);
patch_cls = importdata(patch_cls_str);

fprintf('to learn test part features\n');
parts_hists_test = learn_part_features(test_parts,tests.files_names,tests.histn,patch_cls,2,config);

part_cls_str = strcat(path,config.part_cls_mat);
part_cls = importdata(part_cls_str);

p_occ_prob_str = strcat(path,config.occ_prob_mat);
p_occ_prob = importdata(p_occ_prob_str);

Mdl_str = strcat(path,config.mdl_cvt);
Mdl = importdata(Mdl_str);

weights_str = strcat(path,config.mrf_weights);
w = importdata(weights_str);

mrf_test_all(test_parts,test_patch_names,test_patch_fets,patch_cls,part_cls,p_occ_prob,w,Mdl,config);

%%
% call c++ pcl part store function
ref_path = strcat(pwd,'/code-visualize-parts/build/');
part_seg = strcat(ref_path,'vis'); 
base_dir = strcat(config.orig_path,config.test_part_path);
eval_dir = strcat(config.orig_path,config.parts_save_path);
store_path = strcat(config.orig_path,config.eval_parts_path);
command = strcat(part_seg,{' '},base_dir,{' '},eval_dir,{' '},store_path);
command_str = command{1};
[status,cmdout] = system(command_str,'-echo');
%%